# # #
# /37/euler-021.rb
# (c) 2010 Jan Lelis <mail@janlelis.de>. MIT License.
# See: https://rbjl.janlelis.com/37-project-euler-19-20-21-22-23-24-25-ruby
# # #

# https://projecteuler.net/index.php?section=problems&id=21
#  evaluate the sum of all the "amicable" numbers under 10000

require 'mathn'

class Integer
  def dsum
    return 1 if self < 2

    pd = prime_division.flat_map{ |n, p| [n]*p } # get all prime divisors

    ([1] + (1...pd.size).flat_map{ |e|
      # get all possible prime divisor combinations
      pd.combination(e).map{ |f| f.reduce(:*) }
    }).uniq.reduce(:+) # sum up
  end
end

res = 10_000.times.inject{ |sum, cur|
  other = cur.dsum
  (cur != other && other.dsum == cur) ? sum + cur : sum
}

puts res
